
cra_dir = '/research/handshapes/Quan_Data/pedestrian_data/CRA_code/';
addpath(genpath([cra_dir,'svmlight_mk/']),'-begin');

load([cra_dir,'ped_data'],'pos_train','neg_train','pos_test','ims_train','ims_test');

%%% model parameters, see mk_train.m for details
para.eta = 0.05; para.margin = 2;para.maxiter = 10;
filenames.svml = [cra_dir,'svmlight_mk/'];
filenames.tmp_file = [cra_dir,'ped_mk.cla'];
filenames.cla_file = [cra_dir,'PAS_mkcla'];
pm = mk_train(pos_train,neg_train,para,filenames);

%%%% construct classifiers, weight vectors in CLA, bias in b_theta
xsv_a = single(repmat(pm.alphas,[1,size(pm.xsv,2)]).*pm.xsv);
b_theta = single(pm.ktheta*pm.alphas);
CLA = single(pm.ktheta*xsv_a);
b_theta_rep = repmat(b_theta,[1,size(pos_test,1)]);
%%% evaluate classifiers
scores = CLA * pos_test'+ b_theta_rep;
[ms,mids] = max(scores); %%% find the detector of the highest score for a test examle.

%%%% display the best match for a training image
h1  = figure; h2 = figure;
i = 200;
figure(h1); imagesc(uint8(ims_test{i})); title('test image');axis image;
figure(h2); imagesc(uint8(ims_train{mids(i)})); title('best match in training images');axis image;
