// mex file to read model files trained by modified SVMLight. Assume RBF kernel in parameter space and linear kernel in the feature space
// Quan Yuan
#include "mex.h"
extern "C" {
#include "svm_common.h"
}

// input: model_file
// output: SVs, alphas, rbf_gamma 
void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[]){
	int m,n,f_count, strlen,feature_len;
	int i,j;
	double * ptr,temp;
    char modelfile[1000];
	MODEL * svm_model;

	// first argument is the model file name
	
	strlen = mxGetN(prhs[0]);
    
    m = mxGetString(prhs[0], modelfile, strlen+1);
	
	
    svm_model =  read_binary_model(modelfile);   
    
	plhs[0] = mxCreateDoubleMatrix(svm_model->sv_num -1 , svm_model->totwords, mxREAL); // SVs
	plhs[1] = mxCreateDoubleMatrix(svm_model->sv_num -1, 1, mxREAL); // alphas
	plhs[2] = mxCreateDoubleMatrix(1, 1, mxREAL); // bias
    plhs[3] = mxCreateDoubleMatrix(1, 1, mxREAL); // rbf_gamma
	ptr = mxGetPr(plhs[0]);
    //mexPrintf("sv_num = %d, totwords = %d \n", svm_model->sv_num,svm_model->totwords);
	// total num of SVs is svm_model->sv_num - 1, first sv in model is reserved to be 0 , see line 928 in svm_learn.c
	for(i = 1;i < svm_model->sv_num ; i++)
		for(j = 0; j < svm_model->totwords; j++)
		{
            //temp =  svm_model->supvec[j]->fvec->words[i];
            //mexPrintf("i = %d, j = %d \n", i,j);
			ptr[j*(svm_model->sv_num-1) + i - 1] = svm_model->supvec[i]->fvec->words[j];
	}
	// num of SVs
    ptr = mxGetPr(plhs[1]);
    for(i = 1;i < svm_model->sv_num ; i++)
		ptr[i-1] = svm_model->alpha[i];
    //bias
	ptr = mxGetPr(plhs[2]);
    ptr[0] = svm_model->b;
    // rbf_gamma
	ptr = mxGetPr(plhs[3]);
	ptr[0] = svm_model->kernel_parm.rbf_gamma;
	
}

